﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CardAccess.API;
using CardAccess.Messaging;
using System.Collections;
using CardAccess.KnownObjects.API;

namespace CardAccess.APITest
{
    public partial class FormMain : Form
    {
        private ca4Knet caAccess;
        bool apiInitialized = false;

        public FormMain()
        {
            InitializeComponent();
            try
            {
                caAccess = new ca4Knet();
                caAccess.LogIn("admin", "");
                this.StatusLabel1.Text = caAccess.LastErrorStr;
                this.labelInfo.Text = caAccess.ConnectStr;
                this.richTextBox1.Text = caAccess.ConnectStr;
                if (caAccess.ConnectStr != "")
                {
                    caAccess.OnEventReceived += new ca4Knet.EventReceivedHandler(caAccess_OnEventReceived);
                    apiInitialized = true;
                }
                comboBoxEvtClass.SelectedIndex = 0;

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
                if (caAccess != null) caAccess = null;
            }
        }

        void caAccess_OnEventReceived(object sender, DataEventArgs sde)
        {
            try
            {
                //if (sde.DataPacket.DataObject != null)
                {
                    caAlertData alertData = new caAlertData();
                    alertData = sde.DataPacket.DataObject as caAlertData;
                    if (alertData != null)
                    {
                        string alert = string.Format("Card Access event  : Class: {0} ; Desc : {1} ; Location : {2} ; Cat : {3} ; Status : {4} ; PanelNo : {5} ; DeviceNo : {6} ; Badge : {7} ",
                            alertData.aClass,alertData.aDescription, alertData.aName, alertData.aCat, alertData.aStatus, alertData.aPnlNo, alertData.aDeviceNo, alertData.aBadge);
                        
                        listBoxEvents.BeginInvoke(new Action(delegate()
                        {
                            if (listBoxEvents.Items.Count > 1000)
                                listBoxEvents.Items.Clear();
                            listBoxEvents.Items.Add(alert);
                        }));
                    }
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void tabControl1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (!apiInitialized) return;
            if (tabControl1.SelectedIndex == 1)
            {
                GetAccessGroups(cboAG1);
                GetAccessGroups(cboAG2);
                GetAccessGroups(cboAG3);
                GetAccessGroups(cboAG4);
                GetAccessGroups(cboAG5);
                GetAccessGroups(cboAG6);
                GetAccessGroups(cboAG7);
                GetAccessGroups(cboAG8);
                GetAccessGroups(cboAG9);
                GetAccessGroups(cboAG10);
                GetAccessGroups(cboAG11);
                GetAccessGroups(cboAG12);
                GetAccessGroups(cboAG13);
                GetAccessGroups(cboAG14);
                GetAccessGroups(cboAG15);
                GetAccessGroups(cboAG16);
                this.cboBadgeOpr.SelectedIndex = 0;
            }

            if (tabControl1.SelectedIndex == 2)
            {
                GetPanelsList(cboDoorPanel);

                this.cboDoorOpr.SelectedIndex = 0;
                this.cboDoorNo.SelectedIndex = 0;
            }

            if (tabControl1.SelectedIndex == 3)
            {
                GetPanelsList(cboRelayPanel);

                this.checkedListBoxRelay.Items.Clear();

                for (int i = 1; i < 74; i++)
                {
                    this.checkedListBoxRelay.Items.Add(i.ToString());
                }
                this.cboRelayOpr.SelectedIndex = 0;
            }

            if (tabControl1.SelectedIndex == 4)
            {
                GetPanelsList(cboReaderPanel);
            }

            if (tabControl1.SelectedIndex == 5)
            {
                GetPanelsList(cboPanelPanel);
            }

            if (tabControl1.SelectedIndex == 6)
            {
                GetPanelsList(cboInlistPanel);
            }
            if (tabControl1.SelectedIndex == 7)
            {
                DataTable dt = caAccess.GetLockdownAreas();
                cboLockdownArea.DataSource = dt;
                cboLockdownArea.DisplayMember = "Area Name";
                cboLockdownArea.ValueMember = "Area No";
            }
            if (tabControl1.SelectedIndex == 8)
            {
                DataTable dt = caAccess.GetThreatLevels();
                cboTL.DataSource = dt;
                cboTL.DisplayMember = "Description";
                cboTL.ValueMember = "Level";
            }
            if (tabControl1.SelectedIndex == 9)
            {
                GetPanelsList(cboLinkPanel);
                cboLinkOperation.SelectedIndex = 0;
            }
            if (tabControl1.SelectedIndex == 10)
            {
                GetActivityLinkList(cboActivityLink);
            }
            if (tabControl1.SelectedIndex == 11)
            {
                GetNapcoPanel(cboNapcoPanel);
                cboNapcoOperation.SelectedIndex = 0;
            }
            if (tabControl1.SelectedIndex == 12) //APB Areas
            {
                LoadAPBAreas();
            }
            if (tabControl1.SelectedIndex == 13) //Scripts
            {
                LoadScripts();
            }
            if (tabControl1.SelectedIndex == 14) //ShuntGroups
            {
                LoadShuntGroups();
            }

            if (tabControl1.SelectedIndex == 15) //Lockdown APBArea
            {
                DataTable dt = caAccess.GetLockdownAPBAreas();
                cbAPBArea.DataSource = dt;
                cbAPBArea.DisplayMember = "Description";
                cbAPBArea.ValueMember = "AreaNo";
            }
            if (tabControl1.SelectedIndex == 18) //Execute Script
            {
                DataTable dt = caAccess.GetScripts();
                cboScript.DataSource = dt;
                cboScript.DisplayMember = "scriptName";
                cboScript.ValueMember = "scriptID";
            }
            if (tabControl1.SelectedIndex == 19) //Shunt Groups Operation
            {
                DataTable dt = caAccess.GetShuntGroups();
                cboShuntGroups.DataSource = dt;
                cboShuntGroups.DisplayMember = "ShuntName";
                cboShuntGroups.ValueMember = "ShuntId";
            }
            if (tabControl1.SelectedIndex == 20)// Schedule Changes
            {
                DataTable dt = caAccess.GetScheduleChanges();
                cboChangeSchedule.DataSource = dt;
                cboChangeSchedule.DisplayMember = "Description Text";
                cboChangeSchedule.ValueMember = "caObjectID";
            }
            if (tabControl1.SelectedIndex == 21)
            {
                dtpFromDate.Value = DateTime.Today.AddDays(-1);
                dtpTodate.Value = DateTime.Today;
            }
            if (tabControl1.SelectedIndex == 22)
            {
                dtpAuditFrom.Value = DateTime.Today.AddDays(-1);
                dtpAuditTo.Value = DateTime.Today;
            }
            if (tabControl1.SelectedIndex == 23)
            {
                GetPanelsList(cboFindUsagePanel);
                GetAccessGroups(cboAGUsage);
                GetTimeSchedule(cboTSUsage);
                cboFindUsagePanel.SelectedIndex = 0;
            }
            if (tabControl1.SelectedIndex == 30)
            {
                GetFacilityMaps(cboFacilityMaps);
            }
            if (tabControl1.SelectedIndex == 31)
            {
                GetOrgCategory(cboPivOrgCategory);
                GetPersOrg(cboPivPersOrg);

                GetAccessGroups(cboPivAgNo1);
                GetAccessGroups(cboPivAgNo2);
                GetAccessGroups(cboPivAgNo3);
                GetAccessGroups(cboPivAgNo4);
                GetAccessGroups(cboPivAgNo5);
                GetAccessGroups(cboPivAgNo6);
                GetAccessGroups(cboPivAgNo7);
                GetAccessGroups(cboPivAgNo8);
                GetAccessGroups(cboPivAgNo9);
                GetAccessGroups(cboPivAgNo10);
                GetAccessGroups(cboPivAgNo11);
                GetAccessGroups(cboPivAgNo12);
                GetAccessGroups(cboPivAgNo13);
                GetAccessGroups(cboPivAgNo14);
                GetAccessGroups(cboPivAgNo15);
                GetAccessGroups(cboPivAgNo16);
                this.cboPivBadgeOpr.SelectedIndex = 0;
            }
            if (tabControl1.SelectedIndex == 32)
            {
                GetAccessGroups(cboPiviAgNo1);
                GetAccessGroups(cboPiviAgNo2);
                GetAccessGroups(cboPiviAgNo3);
                GetAccessGroups(cboPiviAgNo4);
                GetAccessGroups(cboPiviAgNo5);
                GetAccessGroups(cboPiviAgNo6);
                GetAccessGroups(cboPiviAgNo7);
                GetAccessGroups(cboPiviAgNo8);
                GetAccessGroups(cboPiviAgNo9);
                GetAccessGroups(cboPiviAgNo10);
                GetAccessGroups(cboPiviAgNo11);
                GetAccessGroups(cboPiviAgNo12);
                GetAccessGroups(cboPiviAgNo13);
                GetAccessGroups(cboPiviAgNo14);
                GetAccessGroups(cboPiviAgNo15);
                GetAccessGroups(cboPiviAgNo16);
                this.cboPiviBadgeOpr.SelectedIndex = 0;
            }
            if (tabControl1.SelectedIndex == 33)
            {
                GetAccessGroups(cboAgEditAgNo1);
                GetAccessGroups(cboAgEditAgNo2);
                GetAccessGroups(cboAgEditAgNo3);
                GetAccessGroups(cboAgEditAgNo4);
                GetAccessGroups(cboAgEditAgNo5);
                GetAccessGroups(cboAgEditAgNo6);
                GetAccessGroups(cboAgEditAgNo7);
                GetAccessGroups(cboAgEditAgNo8);
                GetAccessGroups(cboAgEditAgNo9);
                GetAccessGroups(cboAgEditAgNo10);
                GetAccessGroups(cboAgEditAgNo11);
                GetAccessGroups(cboAgEditAgNo12);
                GetAccessGroups(cboAgEditAgNo13);
                GetAccessGroups(cboAgEditAgNo14);
                GetAccessGroups(cboAgEditAgNo15);
                GetAccessGroups(cboAgEditAgNo16);
            }
            if (tabControl1.SelectedIndex == 36)
            {
                GetTimeSchedules(cboTimeSchedule);
                GetTimeSchedulesTimeBlockIndex(cboTimeBlockIndex, Convert.ToInt32(cboTimeSchedule.SelectedValue));
                GetDaysFromTimeSchedule(cboTimeScheduleDayFrom);
                GetDaysFromTimeSchedule(cboTimeScheduleDayTo);
            }
            if (tabControl1.SelectedIndex == 38)
            {
                GetComServer(cboComServer);
                GetComBAUD(cboComBAUDRate);
                GetComTypeList(cboComType);
                GetComUTCZone(cboComUTCZone);
            }
            if (tabControl1.SelectedIndex == 40)
            {
                GetAccessGroupsForAgSchedule(cboAccessGroup);
                GetPanelsList(cboAGSchedulePanel);
                GetReadersList(cboAGScheduleReader, Convert.ToInt32(cboAGSchedulePanel.SelectedValue));
                GetTimeSchedulesForAgSchedule(cboAGSchedule);
            }
            if (tabControl1.SelectedIndex == 42)
            {
                GetHolidays(cboHolidaysTimeBlock);
                GetHolidaysTimeBlockIndex(cboHolidayTimeBlockIndex, Convert.ToInt32(cboHolidaysTimeBlock.SelectedValue));
            }

            if (tabControl1.SelectedIndex == 43)  // Panel operation
            {
                GetComServer(cboPanelComServer);
                GetComPort(cboPanelComPort);
            }

            if (tabControl1.SelectedIndex == 44)  // Reader Configuration
            {
                GetReadersList(cboRdrConfigAvailableReaders);
                GetPanelsList(cboRdrConfigPanel);
                GetTimeSchedule(cboRdrConfigCardOnlyTimeSched);
                GetTimeSchedule(cboRdrConfigFreeAccessTimeSched);
                GetTimeSchedule(cboRdrConfigDegradeModeTimeSched);
                GetTimeSchedule(cboRdrConfigCommonCodeSched);
                GetTimeSchedule(cboRdrConfigCardPinSched);
                GetTimeSchedule(cboRdrConfigOTLEnableSchedule);
                GetReaderType(cboRdrConfigReaderType);
                GetLockControlType(cboRdrConfigLockControl);
                GetTimeAttendanceType(cboRdrConfigTimeAttendanceType);
                GetTwoManReaderType(cboRdrConfigTwoPersonRrdType);
                GetStdAPBType(cboRdrConfigStdAPBType);
                GetAPBAreasLookup(cboRdrConfigAPBExitFromArea);
                GetAPBAreasLookup(cboRdrConfigAPBEntryToArea);
                GetOTLControlType(cboRdrConfigOTLControlType);
            }
            if (tabControl1.SelectedIndex == 45)
            {
                GetPanelsList(cboLockdownAreaPanel);
                GetReadersList(cboLockdownAreaReader, Convert.ToInt32(cboLockdownAreaPanel.SelectedValue));
            }
            if (tabControl1.SelectedIndex == 46)
            {
                GetLockdownAreas(cboLockdownAreaTLM);
                if (cboLockdownAreaTLM.Items.Count > 0)
                    cboLockdownAreaTLM.SelectedIndex = 0;

                GetThreatLevelCategories(cboCategoryNoTLM);
                if (cboCategoryNoTLM.Items.Count > 0)
                    cboCategoryNoTLM.SelectedIndex = 0;
            }
            if (tabControl1.SelectedIndex == 47)
            {
                GetPanelsList(cboInputOprPanel);
            }
            if (tabControl1.SelectedIndex == 48)
            {
                GetPanelsList(cboRelayOprPanel);
            }
            if (tabControl1.SelectedIndex == 49)
            {
                GetNapcoPanelType(cboNapcoPanelType);
                GetNapcoWorkstation(cboNapcoWorkstation);
            }
            if (tabControl1.SelectedIndex == 50)
            {
                GetActivityLinksForAPBArea(cboLinkOnVacant);
                GetActivityLinksForAPBArea(cboLinkOnOccupied);
                GetActivityLinksForAPBArea(cboLinkProgramIncrease);
                GetActivityLinksForAPBArea(cboLinkProgramDecrease);
            }
            if (tabControl1.SelectedIndex == 52)
            {
                GetOperatorInstructions(cboAvailableInstructions);
            }
            if (tabControl1.SelectedIndex == 53)
            {
                cboInstructionLinkDeviceType.SelectedIndex = 0;
                GetPanelsList(cboInstructionLinkPanel);
                GetDevicesByDeviceType(cboInstructionLinkDevices, Convert.ToInt32(cboInstructionLinkPanel.SelectedValue), cboInstructionLinkDeviceType.SelectedIndex);
                GetEventsForInstructionLinks(cboInstructionLinkEvents, cboInstructionLinkDeviceType.SelectedIndex);
                GetOperatorInstructions(cboInstructionLinkInstruction);
            }
            if (tabControl1.SelectedIndex == 54)
            {
                GetOperatorResponses(cboAvailableOperatorResponse);
            }
            if (tabControl1.SelectedIndex == 55)
            {
                GetNapcoPanel(cboNapcoAreaPanel);
                GetNapcoAreaType(cboNapcoAreaType);
                GetManualPrivilege(cboAreaManualPriv);
            }
            if (tabControl1.SelectedIndex == 56)
            {
                GetNapcoPanel(cboNapcoZonePanel);
            }
            if (tabControl1.SelectedIndex == 57)
            {
                GetNapcoPanel(cboNapcoRelayPanel);
            }
            if (tabControl1.SelectedIndex == 58)
            {
                GetScheduleChanges(cboPrevScheduleChanges);
                cboSchedChangeDeviceType.SelectedIndex = 0;
                GetPanelsList(cboSchedChangesPanel);
                GetDevicesByDeviceType(cboSchedChangeDevices, Convert.ToInt32(cboSchedChangesPanel.SelectedValue), cboSchedChangeDeviceType.SelectedIndex);
                GetTimeSchedules(cboSchedChangeSchedules);
            }
            if (tabControl1.SelectedIndex == 59)
            {
                GetFacilityMaps(cboConfigFacilityMap);
                GetPanelsList(cboFacilityMapPanel);
                GetMapDeviceType(cboFacilityMapDeviceType);
            }
            if (tabControl1.SelectedIndex == 60)
            {
                DataTable dt = caAccess.GetShuntGroups();
                cboPrevShuntGroups.DataSource = dt;
                cboPrevShuntGroups.DisplayMember = "ShuntName";
                cboPrevShuntGroups.ValueMember = "ShuntId";

                GetInputList(chkListBoxShuntGroupInputs);
            }
            if (tabControl1.SelectedIndex == 61)
            {
                GetElevatorFacilities(cboPrevElevatorFacilities);
            }
            if (tabControl1.SelectedIndex == 62)
            {
                GetElevatorServers(cboPrevElevatorServers);
                GetElevatorFacilities(cboElevServerFacilities);
                GetElevatorType(cboElevatorType);
                GetWorkstations(cboEvelServerWorkstations);
            }
            if (tabControl1.SelectedIndex == 63)
            {
                GetElevatorFloors(cboPrevElevatorFloors);
                GetElevatorFacilities(cboElevatorFloorFacilities);
            }
            if (tabControl1.SelectedIndex == 64)
            {
                GetPanelsList(cboFacilityCodePanels);
            }
            if (tabControl1.SelectedIndex == 65)
            {
                GetDVRServerType(cboDVRServerType);
                GetComUTCZone(cboDVRServerTimeZone);
                GetDVRServer(txtDVRServerName);
            }
            if (tabControl1.SelectedIndex == 66)
            {
                GetDVRServer(cboDVRServerID);
                GetTimeSchedules(cboCameraTimeSched);
                GetPriority(cboCameraPriority);
            }
            if (tabControl1.SelectedIndex == 67)
            {
                GetComUTCZone(cboGatewayZone);
                GetComServer(cboGatewayWorkstation);
            }

            if (tabControl1.SelectedIndex == 68)
            {
                GetComServer(cboLockComServer);
                GetComPort(cboLockComport);
            }
            if (tabControl1.SelectedIndex == 69)
            {
                GetAvailableLinkList(cboAvailableLink);
                GetPanelsList(cboLinkPanelNo);
                GetManualPrivilege(cboLinkManualCtrlPriv);
                GetTimeSchedule(cboLinkEnabledSchedule);
                GetLinkList(cboLinkRemoteProg);
                GetInputList(cboLinkInput1);
                GetInputList(cboLinkInput2);
                GetInputList(cboLinkInput3);
                GetInputList(cboLinkInput4);
                GetInputList(cboLinkInput5);
                GetTimeSchedule(cboLinkTrackSchedule);
                GetRelayList(cboLinkOutputOn1);
                GetRelayList(cboLinkOutputOn2);
                GetRelayList(cboLinkOutputOn3);
                GetRelayList(cboLinkOutputOn4);
                GetRelayList(cboLinkOutputOn5);
                GetRelayList(cboLinkOutputOff1);
                GetRelayList(cboLinkOutputOff2);
                GetRelayList(cboLinkOutputOff3);
                GetRelayList(cboLinkOutputOff4);
                GetRelayList(cboLinkOutputOff5);
                GetRelayList(cboLinkOutputTrack1);
                GetRelayList(cboLinkOutputTrack2);
                GetRelayList(cboLinkOutputTrack3);
                GetRelayList(cboLinkOutputTrack4);
                GetRelayList(cboLinkOutputTrack5);
            }
            if (tabControl1.SelectedIndex == 70)
            {
                GetPanelsList(cboALPPanelNo);
                GetManualPrivilege(cboALPManualPrivilege);
                GetTimeSchedule(cboALPCtrlBySchedule);
                GetActivityLinkEvents(cboALPEventName);
                GetActivityLinkUnDo(cboALPUndoALP);
                GetPanelsList(cboALPGlobalPanel);
                GetRelayList(cboALPRelay);
                GetReadersList(cboALPReader);
                GetInputList(cboALPInput);
                GetALPEnforcedReader(cboALPEnforcedRdr);
                GetRelayControl(cboALPRelayCtrl);
                GetReaderControl(cboALPReaderCtrl);
                GetInputControl(cboALPInputCtrl);
                GetCategoryCounter(cboALPPersonnel);
                GetCategoryControl(cboALPPersonnelCtrl);
            }
            if (tabControl1.SelectedIndex == 71)
            {
                GetOperatorRole(cboOperatorPrivRole);
                GetManualPrivilegeCheckList(chkListOpertorManualPriv);
            }
            if (tabControl1.SelectedIndex == 72)
            {
                DataTable dtSd = caAccess.GetStatusDefinition();
                dgStatusDef.DataSource = dtSd;
            }
        }

        private void GetALPEnforcedReader(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetALPEnforcedReader();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetOperatorRole(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetOperatorRolse();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetCategoryControl(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetCatControlList();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetCategoryCounter(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetCategoryCounter();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "Description";
            cboBox.ValueMember = "CatNo";
        }
        private void GetInputControl(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetInputControlList();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetReaderControl(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetRederControlList();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetRelayControl(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetRelayControlList();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetActivityLinkEvents(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetActivityLinkEvents();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "Description";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetAvailableLinkList(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetAvailableLinkList();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "Device Name";
            cboBox.ValueMember = "Panel Prog";
        }
        private void GetRelayList(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetRelayList();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetLinkList(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetLinkList();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetPriority(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetPriority();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetAPBAreasLookup(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetAPBAreasLookup();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetDVRServer(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetDVRServer();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "ServerName";
            cboBox.ValueMember = "DvrID";
        }
        private void GetScheduleChanges(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetScheduleChanges();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "Description Text";
            cboBox.ValueMember = "caObjectID";
        }
        private void GetMapDeviceType(ComboBox cboBox)
        {
            DataTable dt = this.caAccess.GetMapDeviceType();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetOperatorResponses(ComboBox cboBox)
        {
            DataTable dt = this.caAccess.GetOperatorResponses();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "Response Text";
            cboBox.ValueMember = "caobjectid";
        }
        private void GetEventsForInstructionLinks(ComboBox cboBox, int DeviceType)
        {
            DataTable dt = this.caAccess.GetEventsForInstructionLinks(DeviceType);
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetDevicesByDeviceType(ComboBox cboBox, int PnlNo, int DeviceType)
        {
            DataTable dt = this.caAccess.GetDevicesByDeviceType(PnlNo, DeviceType);
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetFieldsByDeviceType(ComboBox cboBox, int DeviceType)
        {
            DataTable dt = this.caAccess.GetFieldsByDeviceType(DeviceType);
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetOperatorInstructions(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetOperatorInstructions();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetNapcoWorkstation(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetNapcoWorkstation(); 
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetNapcoPanelType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetNapcoPanelType();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetHolidaysTimeBlockIndex(ComboBox cboBox, int HolidayCalendarNo)
        {
            DataTable dt = caAccess.GetHolidayTimeBlockIndex(HolidayCalendarNo);
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }

        private void GetHolidays(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetHolidays();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetTimeSchedulesTimeBlockIndex(ComboBox cboBox, int ScheduleNo)
        {
            DataTable dt = caAccess.GetTimeBlockIndexByTimeSchedule(ScheduleNo);
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }

        private void GetTimeSchedules(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetTimeSchedules();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }

        private void GetTimeSchedulesForAgSchedule(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetTimeSchedulesForAgSchedule();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }

        private void GetDaysFromTimeSchedule(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetDaysForTimeSchedule();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }

        private void GetComUTCZone(ComboBox cboBox)
        {
            DataTable dtComServer = caAccess.GetComUTCZone();
            cboBox.DataSource = dtComServer;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }

        private void GetComTypeList(ComboBox cboBox)
        {
            DataTable dtComServer = caAccess.GetComTypeList();
            cboBox.DataSource = dtComServer;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetComBAUD(ComboBox cboBox)
        {
            DataTable dtComServer = caAccess.GetComBAUD();
            cboBox.DataSource = dtComServer;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.SelectedIndex = 5;
        }
        private void GetComServer(ComboBox cboBox)
        {
            DataTable dtComServer = caAccess.GetComServer();
            cboBox.DataSource = dtComServer;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetComPort(ComboBox cboBox)
        {
            DataTable dtComServer = caAccess.GetComPort();
            cboBox.DataSource = dtComServer;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetOrgCategory(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetOrgCategory();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetThreatLevelCategories(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetThreatLevelCategories();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "CatNumber";
            cboBox.ValueMember = "CatNumber";
        }
        private void GetPersOrg(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetPersOrg();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetLockdownAreas(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetLockdownAreas();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetFacilityMaps(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetFacilityMaps();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "MapName";
            cboBox.ValueMember = "MapId";
        }

        private void GetTimeSchedule(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetTimeSchedule();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetAccessGroups(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetAccessGroups();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetAccessGroupsForAgSchedule(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetAccessGroupsForAgSchedule();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetPanelsList(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetPanels();
            cboBox.DisplayMember = "Device Name";
            cboBox.ValueMember = "PnlNo";
            cboBox.DataSource = dt;
        }

        private void GetInputList(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetInputsLookup();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }

        private void GetInputList(CheckedListBox chkListBox)
        {
            DataTable dt = caAccess.GetInputs();
            chkListBox.DataSource = dt;
            chkListBox.DisplayMember = "Device Name";
        }
        private void GetManualPrivilegeCheckList(CheckedListBox chkListBox)
        {
            DataTable dt = caAccess.GetManualPrivilege();
            chkListBox.DataSource = dt;
            chkListBox.DisplayMember = "DisplayMember";
        }
        private void GetReadersList(ComboBox cboBox, int PnlNo = 0)
        {
            DataTable dt = caAccess.GetReaders(PnlNo);
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "Device Name";
            cboBox.ValueMember = "RdrNo";
        }
        private void GetReaderType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetReaderType();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetStdAPBType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetStdAPBType();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetOTLControlType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetOTLControlType();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetLockControlType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetLockControlType();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetTimeAttendanceType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetTimeAttendanceType();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetTwoManReaderType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetTwoManReaderType();
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
        }
        private void GetLinkList(ComboBox cboBox, int PnlNo)
        {
            DataTable dt = caAccess.GetLinks(PnlNo);
            cboBox.DataSource = dt;
            cboBox.DisplayMember = "Device Name";
            cboBox.ValueMember = "ProgNo";
        }

        private DataTable ActivityList = null;
        private void GetActivityLinkList(ComboBox cboBox)
        {
            ActivityList = caAccess.GetActivityLinks();
            cboBox.DisplayMember = "ALP Description";
            cboBox.ValueMember = "PnlProg";
            cboBox.DataSource = ActivityList;
        }
        private void GetActivityLinkUnDo(ComboBox cboBox)
        {
            ActivityList = caAccess.GetActivityLinks();
            cboBox.DisplayMember = "ALP Description";
            cboBox.ValueMember = "ProgNo";
            cboBox.DataSource = ActivityList;
        }
        private void GetActivityLinksForAPBArea(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetActivityLinksForAPBArea();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetNapcoPanel(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetNapcoPanel();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetNapcoAreaType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetNapcoAreaType();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetManualPrivilege(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetManualPrivilege();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetDVRServerType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetDVRServerType();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetAvailableLanguages(ComboBox cboBox, string LanguagesPath)
        {
            DataTable dt = caAccess.GetAvailableLanguages(LanguagesPath);
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetNapcoAreaList(int PnlNo=0)
        {
            DataTable dt = caAccess.GetNapcoAreaList(PnlNo);
            chkNapcoAreaList.Items.Clear();
            foreach (DataRow item in dt.Rows)
            {
                chkNapcoAreaList.Items.Add(item["AreaName"].ToString() + ":" + item["AreaNumber"].ToString());
            }
        }
        private void GetElevatorFloors(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetElevatorFloors();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetElevatorServers(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetElevatorServers();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetElevatorType(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetElevatorType();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetElevatorFacilities(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetElevatorFacilities();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void GetWorkstations(ComboBox cboBox)
        {
            DataTable dt = caAccess.GetWorkstations();
            cboBox.DisplayMember = "DisplayMember";
            cboBox.ValueMember = "ValueMember";
            cboBox.DataSource = dt;
        }
        private void executeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (!apiInitialized) return;

            #region "test shortcut"
            //UInt16 Facility = 0;
            //UInt64 BadgeA = 1974;
            //UInt16 AGseqNo = 1;
            //UInt16 AGNo = 2;
            //DateTime agActTime = DateTime.Parse(@"11/04/2020 9:31:35 AM");
            //DateTime agDeactTime = DateTime.Parse(@"12/05/2020 9:31:35 AM");
            //caAccess.UpdateBadgeAccessGroup(Facility, BadgeA, AGseqNo, AGNo, agActTime, agDeactTime);


            //string filterOption = "badge";
            //string filterText = "100";
            //DataTable dt = caAccess.GetPersons(filterOption, filterText);


            //DateTime startDate= DateTime.Parse(@"11/04/2020 9:31:35 AM");
            //DateTime endDate = DateTime.Parse(@"12/05/2020 9:31:35 AM");
            //DataTable dt = caAccess.GetEvents(startDate, endDate);

            //int abadge = 15262;
            //int afac = 0;
            //DataTable dt = caAccess.GetAccessGroupForBadge(abadge, afac);


            #region "Auto-Owners"
            //DateTime dt1, dt1Utc, dt2, dt2Utc;

            //string sdt1 = "12/31/2020 04:22:35 PM";  //"10/01/2018 9:31:35 AM";
            //dt1 = DateTime.Parse(sdt1);
            //dt1Utc = dt1.AddMinutes(Napco.Common.MiscUtils.GetUTCOffset*-1);

            //string sdt2 = "12/31/2020 05:05:35 PM";  //"12/31/2020 9:31:35 AM";
            //dt2 = DateTime.Parse(sdt2);
            //dt2Utc = dt2.AddMinutes(Napco.Common.MiscUtils.GetUTCOffset*-1);

            ////var ds = caAccess.GetEventReportDS(sdt1, sdt2, erf);  //[Route("Report\Event")]
            //sdt1 = dt1Utc.ToString("MM/dd/yyyy HH:mm:ss");          //HH -> 24 hr format
            //sdt2 = dt2Utc.ToString("MM/dd/yyyy HH:mm:ss");

            //var erf = new EventReportFilter
            //{
            //    CompanyName = "15265-Company"
            //};
            //List<KnownObjects.entities.Event> eventReport = caAccess.GetEventReport(sdt1, sdt2, erf);  //[Route("Reports\Events")]
            //return;
            //DataTable dt;

            //dt = caAccess.GetAllBadgeHolders("3DC78C7B-C9CE-4485-A835-63D577F623E6");   //[Route("AllBadgeHolders")]

            //string dd1 = "12/01/2020", dd2 = "12/09/2020";
            //DateTime dt1 = DateTime.Parse(dd1), dt2 = DateTime.Parse(dd2);
            //DataTable dat1 = caAccess.GetEvents(DateTime.Parse(dd1), DateTime.Parse(dd2));

            //DataTable dat2 = caAccess.GetBadgeEvents(dt1, dt2, 7280);
            //dt = caAccess.GetAllBadgesByPersonName("15262", "Chu");

            //var bf = new BadgeFilter
            //{
            //    CompanyName = "15265-Company"
            //};
            //var ds = caAccess.GetBadgeADS(bf);
            //var badgeA = caAccess.GetBadgeA(bf);
            //return;
            #endregion  "end Auto-Owners"


            #region "CSU - CHICO"
            //UInt32 NewBadge = 678;
            //string emplid ="";
            //string FrstName = "bob";
            //string LastName = "chico";
            //ushort PIN =0;
            //Guid uid;

            ////1. insert new
            //UInt16 Facility = 0;
            //string MiddleName = "";
            ////ushort[] agnos = new ushort[] { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            //ushort[] agnos = new ushort[] { 1 };


            //caAccess.BadgeOperation(Facility, NewBadge, FrstName, LastName, MiddleName, agnos, 0, PIN: PIN);

            ////2. add 2nd card to exist 1974
            //DateTime[] actDeact = { new DateTime(2020, 1, 1), new DateTime(2099, 1, 1) };
            ////Get Old badge activation and deactivation
            //DataTable personInfo = caAccess.GetPersons("badge", "1974");

            ////Get User Infrom from CA4k
            //DataRow badgeInfo = caAccess.GetBadgeInfo(1974, 0).Rows[0];

            //Facility = Convert.ToUInt16(badgeInfo["Facility"]);
            //FrstName = badgeInfo["FrstName"].ToString();
            //LastName = badgeInfo["LastName"].ToString();
            //MiddleName = badgeInfo["MiddleName"].ToString();
            //if (!(badgeInfo["PIN"] is DBNull) && PIN == null)
            //{
            //    PIN = Convert.ToUInt16(badgeInfo["PIN"]);
            //}
            ////Access group information
            //agnos = new ushort[] { Convert.ToUInt16(badgeInfo["AG1"]) };
            ////Get Emplid
            //emplid = "123";
            ////Add new badge to system
            //uid = Guid.Parse(badgeInfo["PersonID"].ToString());
            //caAccess.BadgeOperation(Facility, NewBadge, FrstName, LastName, MiddleName, agnos, 0, uid, PIN);

            //////Update badge access
            //caAccess.UpdateBadgeParams(Facility, Convert.ToUInt32(NewBadge), actDeact[0], actDeact[1]);
            //////caAccess.UpdateBadgeCustomField(Facility, NewBadge, 6, emplid);
            #endregion "end CSU - CHICO"

            #region "ARAS"
            //caAccess.ResetGlobalAPBStatus(255);
            //string dd1 = "05/01/2021", dd2 = "06/09/2021";
            //DateTime act = DateTime.Parse(dd1);
            //DateTime exp = default(DateTime);
            //var ret = caAccess.UpdateBadgeParams(
            //    0
            //    , 1001
            //    , act
            //    , null
            //    , 1
            //    , 0
            //    , 0
            //    , 0
            //    , 0
            //    , 123456
            //);

            //act = DateTime.Parse(dd1);
            //exp = DateTime.Parse(dd2);
            //ret = caAccess.UpdateBadgeParams(
            //    0
            //    , 1001
            //    , act
            //    , exp
            //    , 1
            //    , 0
            //    , 0
            //    , 0
            //    , 0
            //    , 123456
            //);
            //return;
            #endregion "end test ARAS"

            #endregion "end test shortcut"


            this.StatusLabel1.Text = "Executing..."; //Empty status on every click
            Application.DoEvents();
            System.Threading.Thread.Sleep(200);
            if (tabControl1.SelectedIndex == 1) //Badge operation
            {
                int Result = -1;
                ushort v1, v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18;
                UInt64 v2;
                v1 = (ushort)this.numericUpDown1.Value;
                v2 = Convert.ToUInt64(this.txtBxBadge.Text);
                v3 = Convert.ToUInt16(cboAG1.SelectedValue);
                v4 = Convert.ToUInt16(cboAG2.SelectedValue);
                v5 = Convert.ToUInt16(cboAG3.SelectedValue);
                v6 = Convert.ToUInt16(cboAG4.SelectedValue);
                v7 = Convert.ToUInt16(cboAG5.SelectedValue);
                v8 = Convert.ToUInt16(cboAG6.SelectedValue);
                v9 = Convert.ToUInt16(cboAG7.SelectedValue);
                v10 = Convert.ToUInt16(cboAG8.SelectedValue);
                v11 = Convert.ToUInt16(cboAG9.SelectedValue);
                v12 = Convert.ToUInt16(cboAG10.SelectedValue);
                v13 = Convert.ToUInt16(cboAG11.SelectedValue);
                v14 = Convert.ToUInt16(cboAG12.SelectedValue);
                v15 = Convert.ToUInt16(cboAG13.SelectedValue);
                v16 = Convert.ToUInt16(cboAG14.SelectedValue);
                v17 = Convert.ToUInt16(cboAG15.SelectedValue);
                v18 = Convert.ToUInt16(cboAG16.SelectedValue);
                Result = this.caAccess.BadgeOperation(v1, v2,
                                                       tbFirstName.Text,
                                                       tbLastName.Text,
                                                       tbMI.Text,
                                                       v3, v4, v5, v6, v7, v8, v9, v10, v11, v12, v13, v14, v15, v16, v17, v18,
                                                       (ushort)cboBadgeOpr.SelectedIndex);
                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    case -2:
                        this.StatusLabel1.Text = "Invalid Badge";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }

            if (tabControl1.SelectedIndex == 2) //Door operation
            {
                int Result = -1;
                ushort v1, v2, v3, v4;
                v1 = Convert.ToUInt16(cboDoorPanel.SelectedValue);
                v2 = Convert.ToUInt16(cboDoorNo.SelectedIndex + 1);
                v3 = (ushort)this.numericUpDown3.Value;
                v4 = (ushort)cboDoorOpr.SelectedIndex;
                Result = caAccess.DoorOperation(v1, v2, v3, v4);
                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    case -2:
                        this.StatusLabel1.Text = "Invalid Door";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }

            if (tabControl1.SelectedIndex == 3) //Realy operation
            {
                int Result = -1;
                ushort v1, v2;
                v1 = Convert.ToUInt16(cboRelayPanel.SelectedValue);
                v2 = Convert.ToUInt16(cboRelayOpr.SelectedIndex + 1);
                //v3 = (ushort)this.numericUpDown3.Value;
                //v4 = (ushort)comboBox10.SelectedIndex;

                UInt16[] rl = new ushort[this.checkedListBoxRelay.CheckedItems.Count + 1];
                //UInt16* ps = stackalloc UInt16[this.checkedListBox1.CheckedItems.Count];

                int j = 0;

                foreach (int indexChecked in checkedListBoxRelay.CheckedIndices)
                {
                    rl[j] = (ushort)(indexChecked + 1);
                    j++;
                }

                Result = caAccess.RelayOperation(v1, v2, rl, (ushort)this.checkedListBoxRelay.CheckedItems.Count, 0);

                DisplyResult(Result);
            }

            if (tabControl1.SelectedIndex == 4) //Reader operation
            {
                int Result = -1;
                ushort v1, v2;
                v1 = Convert.ToUInt16(cboReaderPanel.SelectedValue);
                v2 = Convert.ToUInt16(cboReaderReader.SelectedValue);

                Result = caAccess.ReaderOperation(v1, v2, checkBox2.Checked);

                DisplyResult(Result);
            }

            if (tabControl1.SelectedIndex == 5) //Panel operation
            {
                int Result = -1;
                ushort v1;
                v1 = Convert.ToUInt16(cboPanelPanel.SelectedValue);

                Result = caAccess.PanelOperation(v1, checkBox3.Checked);

                DisplyResult(Result);
            }

            if (tabControl1.SelectedIndex == 6) //Inlist operation
            {
                int Result = -1;
                listBoxInlist.Items.Clear();
                UInt16 rs = 0;
                UInt64[] bl = new UInt64[rs];
                UInt16 v1, v2;
                v1 = Convert.ToUInt16(cboInlistPanel.SelectedValue);
                v2 = Convert.ToUInt16(cboInlistReader.SelectedValue);



                Result = caAccess.InlistQuery(v1, v2, bl, out rs);

                if (rs > 0)
                {
                    bl = new UInt64[rs];
                    Result = caAccess.InlistQuery(v1, v2, bl, out rs);
                    foreach (UInt64 bn in bl)
                    {
                        listBoxInlist.Items.Add(bn.ToString());
                    }
                }

                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 7) //Lockdown operation
            {
                int Result = -1;
                ushort v1;
                v1 = Convert.ToUInt16(cboLockdownArea.SelectedValue);

                Result = caAccess.LockdownArea(v1, chkLock.Checked);

                DisplyResult(Result);
            }

            if (tabControl1.SelectedIndex == 8) //Threat level operation
            {
                int Result = -1;
                ushort v1;
                v1 = Convert.ToUInt16(cboTL.SelectedValue);

                Result = caAccess.ThreatLevelActivate(v1, chkTLActivate.Checked);

                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 9) //Links operation
            {
                int Result = -1;
                ushort v1, v2, v3;
                v1 = Convert.ToUInt16(cboLinkPanel.SelectedValue);
                v2 = Convert.ToUInt16(cboLink.SelectedValue);
                v3 = (ushort)cboLinkOperation.SelectedIndex;
                Result = caAccess.LinkOperation(v1, v2, v3);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 10) //ActivityLinks operation
            {
                int Result = -1;
                ushort v1 = 0, v2 = 0;
                try
                {
                    DataRow[] dr = ActivityList.Select("PnlProg = '" + cboActivityLink.SelectedValue + "'");
                    if (dr != null && dr.Length > 0)
                    {
                        foreach (var item in dr)
                        {
                            v1 = (ushort)(int)item["PnlRef"];
                            v2 = (ushort)(int)item["ProgNo"];
                        }
                    }
                }
                catch (Exception ex)
                {
                    throw ex;
                }

                Result = caAccess.ActivityLinkOperation(v1, v2, chkUndo.Checked);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 11)//Napco Area operation
            {
                int Result = -1;
                ushort areas = 0;
                foreach (string chk in chkNapcoAreaList.CheckedItems)
                {
                    string[] s = chk.Split(':');
                    areas += (byte)(1 << (Convert.ToSByte(s[1]) - 1));
                }

                bool isarm = (ushort)cboNapcoOperation.SelectedIndex == 0 ? true : false;
                ushort pnlNo = Convert.ToUInt16(cboNapcoPanel.SelectedValue);
                Result = caAccess.NapcoAreaOperation(pnlNo, areas, isarm);
            }

            if (tabControl1.SelectedIndex == 15) //Lockdown APB Area operation
            {
                try
                {
                    int Result = -1;
                    ushort v1;
                    v1 = Convert.ToUInt16(cbAPBArea.SelectedValue);

                    Result = caAccess.LockdownAPBArea(v1, chkLock.Checked);

                    DisplyResult(Result);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
            if (tabControl1.SelectedIndex == 16) //Reset Badge APB Status
            {
                try
                {
                    int Result = -1;
                    ushort v1 = Convert.ToUInt16(txtBadgeAPBStatus.Text);
                    ushort v2 = Convert.ToUInt16(txtFacilityAPBStatus.Text);
                    ushort v3 = Convert.ToUInt16(txtSetAPBStatus.Text);

                    Result = caAccess.ResetBadgeAPBStatus(v1, v2, v3);

                    DisplyResult(Result);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
            if (tabControl1.SelectedIndex == 17) //Reset Global APB Status
            {
                try
                {
                    int Result = -1;
                    ushort v1 = Convert.ToUInt16(txtResetArea.Text);
                    DateTime v2 = Convert.ToDateTime(dtpAPBResetTime.Value);

                    Result = caAccess.ResetGlobalAPBStatus(v1, v2);

                    DisplyResult(Result);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
            if (tabControl1.SelectedIndex == 18) //ExcecuteScript
            {
                try
                {
                    int Result = -1;
                    ushort v1 = Convert.ToUInt16(cboScript.SelectedValue);
                    Result = caAccess.ExcecuteScript(v1);

                    DisplyResult(Result);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
            if (tabControl1.SelectedIndex == 19) //Shunt Groups Operation
            {
                try
                {
                    int Result = -1;
                    ushort v1 = Convert.ToUInt16(cboShuntGroups.SelectedValue);
                    Result = caAccess.ShuntGroupOperation(v1, (ushort)(chkShuntGroupActive.Checked ? 1 : 0));

                    DisplyResult(Result);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }
            if (tabControl1.SelectedIndex == 20) //Cancel Active Schedule Changes
            {
                try
                {
                    int Result = -1;
                    Guid v1 = (Guid)(cboChangeSchedule.SelectedValue);
                    Result = caAccess.CancelActiveSchduleChange(v1, chkCancelActiveSchChanges.Checked);

                    DisplyResult(Result);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
            }

            if (tabControl1.SelectedIndex == 21)//Events
            {
                DataTable dtEvents = caAccess.GetEvents(dtpFromDate.Value, dtpTodate.Value);
                gdEvents.DataSource = dtEvents;
                gbEvents.Text = "Events (" + dtEvents.Rows.Count + ")";

                DataTable dtPending = caAccess.GetPendingEvents();
                gdPending.DataSource = dtPending;
                gbPendingEvents.Text = "Pending Events (" + dtPending.Rows.Count + ")";
            }
            if (tabControl1.SelectedIndex == 22)//Audit Log
            {
                DataTable dtAuditTrail = caAccess.GetAuditTrail(dtpAuditFrom.Value, dtpAuditTo.Value);
                gdAuditLog.DataSource = dtAuditTrail;
                gbAudit.Text = "Autid Trail (" + dtAuditTrail.Rows.Count + ")";
            }
            if (tabControl1.SelectedIndex == 23)//Find Usage
            {
                //Done in combobox event handlers
            }
            if (tabControl1.SelectedIndex == 24)
            {
                DataTable lockDownSts = caAccess.GetLockdownStatus();
                gdLockdownStatus.DataSource = lockDownSts;
            }
            if (tabControl1.SelectedIndex == 25)
            {
                DataTable pnlStatus = caAccess.GetPanelStatus();
                gdPanelStatus.DataSource = pnlStatus;
            }
            if (tabControl1.SelectedIndex == 26)
            {
                DataTable gatewaysStatus = caAccess.GetGatewaysStatus();
                gdGatewaysStatus.DataSource = gatewaysStatus;
            }
            if (tabControl1.SelectedIndex == 27)
            {
                DataTable locksStatus = caAccess.GetLocksStatus();
                gdLocksStatus.DataSource = locksStatus;
            }
            if (tabControl1.SelectedIndex == 28)
            {
                DataTable deviceStatus = caAccess.GetDeviceStatus(0); //0 for all devices
                dgDeviceStatus.DataSource = deviceStatus;
            }
            if (tabControl1.SelectedIndex == 29)
            {
                DataTable napcoStatus = caAccess.GetNapcoStatus();
                dgNapcoStatus.DataSource = napcoStatus;
            }
            if (tabControl1.SelectedIndex == 30)
            {
                if (cboFacilityMaps.SelectedValue != null && tabControl1.SelectedIndex == 30)
                {
                    int Result = -1;
                    try
                    {
                        if (pbFacilityMaps.Image != null)
                        {
                            if (cboFacilityMaps.SelectedValue != null && tabControl1.SelectedIndex == 30)
                            {
                                if (((DataRowView)cboFacilityMaps.SelectedItem).Row["MapId"] != null && !string.IsNullOrEmpty(((DataRowView)cboFacilityMaps.SelectedItem).Row["MapId"].ToString()))
                                {
                                    Result = caAccess.ChangeFacilityMap((int)(((DataRowView)cboFacilityMaps.SelectedItem).Row["MapId"]), pbFacilityMaps.Image);
                                    DisplyResult(Result);
                                    if (Result != -1)
                                    {
                                        int prevIndex = cboFacilityMaps.SelectedIndex;
                                        GetFacilityMaps(cboFacilityMaps);
                                        cboFacilityMaps.SelectedIndex = prevIndex;
                                    }
                                }
                            }
                        }
                    }
                    catch { }
                }
            }
            if (tabControl1.SelectedIndex == 31) //PIV Badge operation
            {
                int Result = -1;
                try
                {
                    UInt64 pivBadge, persPIVId;
                    ushort agencyCode, orgCategory, orgAssoc, siteno, issue, series, orgId;
                    ushort[] agNos = new ushort[16];

                    pivBadge = Convert.ToUInt64(txtPivBadge.Text);
                    persPIVId = Convert.ToUInt64(string.IsNullOrWhiteSpace(txtPersPivId.Text) ? "0" : txtPersPivId.Text);
                    agencyCode = Convert.ToUInt16(txtPivAgencyCode.Text);
                    orgCategory = Convert.ToUInt16(cboPivOrgCategory.SelectedValue);
                    orgAssoc = Convert.ToUInt16(cboPivPersOrg.SelectedValue);
                    siteno = Convert.ToUInt16(txtPivSiteNo.Text);
                    issue = (ushort)this.numPivIssue.Value;
                    series = (ushort)this.numPivSeries.Value;
                    orgId = Convert.ToUInt16(txtPivOrgId.Text);

                    agNos[0] = Convert.ToUInt16(cboPivAgNo1.SelectedValue);
                    agNos[1] = Convert.ToUInt16(cboPivAgNo2.SelectedValue);
                    agNos[2] = Convert.ToUInt16(cboPivAgNo3.SelectedValue);
                    agNos[3] = Convert.ToUInt16(cboPivAgNo4.SelectedValue);
                    agNos[4] = Convert.ToUInt16(cboPivAgNo5.SelectedValue);
                    agNos[5] = Convert.ToUInt16(cboPivAgNo6.SelectedValue);
                    agNos[6] = Convert.ToUInt16(cboPivAgNo7.SelectedValue);
                    agNos[7] = Convert.ToUInt16(cboPivAgNo8.SelectedValue);
                    agNos[8] = Convert.ToUInt16(cboPivAgNo9.SelectedValue);
                    agNos[9] = Convert.ToUInt16(cboPivAgNo10.SelectedValue);
                    agNos[10] = Convert.ToUInt16(cboPivAgNo11.SelectedValue);
                    agNos[11] = Convert.ToUInt16(cboPivAgNo12.SelectedValue);
                    agNos[12] = Convert.ToUInt16(cboPivAgNo13.SelectedValue);
                    agNos[13] = Convert.ToUInt16(cboPivAgNo14.SelectedValue);
                    agNos[14] = Convert.ToUInt16(cboPivAgNo15.SelectedValue);
                    agNos[15] = Convert.ToUInt16(cboPivAgNo16.SelectedValue);

                    Result = this.caAccess.PivBadgeOperation(pivBadge, txtPivFirstName.Text, txtPivLastName.Text, txtPivMI.Text, agencyCode, orgCategory,
                                                            orgAssoc, siteno, issue, series, persPIVId, orgId, agNos, (ushort)cboPivBadgeOpr.SelectedIndex);
                }
                catch { }

                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    case -2:
                        this.StatusLabel1.Text = "Invalid Badge";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 32) //PIVI Badge operation
            {
                int Result = -1;
                try
                {
                    ushort[] agNos = new ushort[16];
                    agNos[0] = Convert.ToUInt16(cboPiviAgNo1.SelectedValue);
                    agNos[1] = Convert.ToUInt16(cboPiviAgNo2.SelectedValue);
                    agNos[2] = Convert.ToUInt16(cboPiviAgNo3.SelectedValue);
                    agNos[3] = Convert.ToUInt16(cboPiviAgNo4.SelectedValue);
                    agNos[4] = Convert.ToUInt16(cboPiviAgNo5.SelectedValue);
                    agNos[5] = Convert.ToUInt16(cboPiviAgNo6.SelectedValue);
                    agNos[6] = Convert.ToUInt16(cboPiviAgNo7.SelectedValue);
                    agNos[7] = Convert.ToUInt16(cboPiviAgNo8.SelectedValue);
                    agNos[8] = Convert.ToUInt16(cboPiviAgNo9.SelectedValue);
                    agNos[9] = Convert.ToUInt16(cboPiviAgNo10.SelectedValue);
                    agNos[10] = Convert.ToUInt16(cboPiviAgNo11.SelectedValue);
                    agNos[11] = Convert.ToUInt16(cboPiviAgNo12.SelectedValue);
                    agNos[12] = Convert.ToUInt16(cboPiviAgNo13.SelectedValue);
                    agNos[13] = Convert.ToUInt16(cboPiviAgNo14.SelectedValue);
                    agNos[14] = Convert.ToUInt16(cboPiviAgNo15.SelectedValue);
                    agNos[15] = Convert.ToUInt16(cboPiviAgNo16.SelectedValue);

                    Result = this.caAccess.PiviBadgeOperation(txtPivData.Text, txtPiviFirstName.Text, txtPiviLastName.Text, txtPiviMi.Text, agNos, (ushort)cboPiviBadgeOpr.SelectedIndex);
                }
                catch { }

                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    case -2:
                        this.StatusLabel1.Text = "Invalid Badge";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 33) //AG Edit
            {
                int Result = -1;
                try
                {
                    UInt64 Badge = Convert.ToUInt64(txtAgEditBadge.Text);
                    ushort fac = (ushort)this.numAgEditFacility.Value;

                    ushort[] agNos = new ushort[16];
                    agNos[0] = Convert.ToUInt16(cboAgEditAgNo1.SelectedValue);
                    agNos[1] = Convert.ToUInt16(cboAgEditAgNo2.SelectedValue);
                    agNos[2] = Convert.ToUInt16(cboAgEditAgNo3.SelectedValue);
                    agNos[3] = Convert.ToUInt16(cboAgEditAgNo4.SelectedValue);
                    agNos[4] = Convert.ToUInt16(cboAgEditAgNo5.SelectedValue);
                    agNos[5] = Convert.ToUInt16(cboAgEditAgNo6.SelectedValue);
                    agNos[6] = Convert.ToUInt16(cboAgEditAgNo7.SelectedValue);
                    agNos[7] = Convert.ToUInt16(cboAgEditAgNo8.SelectedValue);
                    agNos[8] = Convert.ToUInt16(cboAgEditAgNo9.SelectedValue);
                    agNos[9] = Convert.ToUInt16(cboAgEditAgNo10.SelectedValue);
                    agNos[10] = Convert.ToUInt16(cboAgEditAgNo11.SelectedValue);
                    agNos[11] = Convert.ToUInt16(cboAgEditAgNo12.SelectedValue);
                    agNos[12] = Convert.ToUInt16(cboAgEditAgNo13.SelectedValue);
                    agNos[13] = Convert.ToUInt16(cboAgEditAgNo14.SelectedValue);
                    agNos[14] = Convert.ToUInt16(cboAgEditAgNo15.SelectedValue);
                    agNos[15] = Convert.ToUInt16(cboAgEditAgNo16.SelectedValue);

                    Result = this.caAccess.UpdateBadgeAccessGroup(fac, Badge, agNos);
                }
                catch { }

                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    case -2:
                        this.StatusLabel1.Text = "Invalid Badge";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 34) //Photo Edit
            {
                int Result = -1;

                UInt64 Badge = Convert.ToUInt64(txtPhotoEditBadge.Text);
                ushort fac = (ushort)this.numPhotoEditFacility.Value;
                Result = this.caAccess.UpdateBadgePhoto(fac, Badge, pbPhotoEditPhoto.Image);

                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    case -2:
                        this.StatusLabel1.Text = "Invalid Badge";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 35)
            {
                int Result = -1;
                Result = this.caAccess.TimeScheduleOperation(txtTimeScheduleName.Text, Convert.ToInt32(numScheduleNo.Value), (ushort)cboTimeScheduleOperation.SelectedIndex);
                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 36)
            {
                int Result = -1;
                Result = this.caAccess.TimeScheduleTimeBlockOperation(Convert.ToInt32(numScheduleNo.Value), Convert.ToInt32(cboTimeBlockIndex.SelectedValue), Convert.ToInt32(cboTimeScheduleDayFrom.SelectedValue), Convert.ToInt32(cboTimeScheduleDayTo.SelectedValue), dtpTimeScheduleTimeTo.Value, dtpTimeScheduleTimeFrom.Value, (ushort)cboTimeScheduleBlockOperation.SelectedIndex);
                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        GetTimeSchedulesTimeBlockIndex(cboTimeBlockIndex, Convert.ToInt32(cboTimeSchedule.SelectedValue));
                        GetDaysFromTimeSchedule(cboTimeScheduleDayFrom);
                        GetDaysFromTimeSchedule(cboTimeScheduleDayTo);
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 37) //Add Com Server
            {
                int Result = -1;
                Result = this.caAccess.ComServerOperaton(txtComSrvDescription.Text, txtUNCName.Text, (int)numHCSNo.Value, (ushort)cboComSvrOperation.SelectedIndex);
                string msg = "Com Exists";
                DisplyResult(Result, msg);
            }

            if (tabControl1.SelectedIndex == 38) //Add Com Server
            {
                int Result = -1;
                Result = this.caAccess.ComChannelOperation(Convert.ToUInt16(cboComServer.SelectedValue), Convert.ToUInt16(numComPort.Value), Convert.ToUInt16(cboComType.SelectedValue), Convert.ToInt32(cboComBAUDRate.SelectedValue), txtComIPAdd.Text.ToString(), Convert.ToUInt16(cboComUTCZone.SelectedValue), (ushort)cboComPortOperation.SelectedIndex);
                DisplyResult(Result);
            }

            if (tabControl1.SelectedIndex == 39)
            {
                int Result = -1;
                Result = this.caAccess.AccessGroupOperation(txtAccessGroupName.Text, Convert.ToInt32(numAccesGroupNo.Value), (ushort)cboAccessGroupOperation.SelectedIndex);
                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 40)
            {
                int Result = -1;
                Result = this.caAccess.SetAccessGroupReaderSchedule(Convert.ToInt32(cboAccessGroup.SelectedValue), Convert.ToInt32(cboAGSchedulePanel.SelectedValue), Convert.ToInt32(cboAGScheduleReader.SelectedValue), Convert.ToInt32(cboAGSchedule.SelectedValue));
                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 41)
            {
                int Result = -1;
                Result = this.caAccess.HolidaysOperation(txtHolidaysName.Text, Convert.ToInt32(numHolidayCalendarNo.Value), (ushort)cboHolidaysOperation.SelectedIndex);
                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 42)
            {
                int Result = -1;
                Result = this.caAccess.HolidaysTimeBlockOperation(Convert.ToInt32(cboHolidaysTimeBlock.SelectedValue), Convert.ToInt32(cboHolidayTimeBlockIndex.SelectedValue), dtpDateHolidayTimeBlockOpr.Value, dtpStartTimeHolidayTimeBlockOpr.Value, dtpEndTimeHolidayTimeBlockOpr.Value, (ushort)cboHolidayTimeBlockOperation.SelectedIndex);
                switch (Result)
                {
                    case 0:
                        this.StatusLabel1.Text = "Successful";
                        GetHolidaysTimeBlockIndex(cboHolidayTimeBlockIndex,Convert.ToInt32(cboHolidaysTimeBlock.SelectedValue));
                        break;
                    case -1:
                        this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                        break;
                    default:
                        this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                        break;
                }
            }
            if (tabControl1.SelectedIndex == 43)//Panel Operation
            {
                int Result = -1;
                Result = caAccess.PanelOperation(Convert.ToUInt16(cboPanelComServer.SelectedValue), Convert.ToUInt16(cboPanelComPort.SelectedValue), Convert.ToUInt16(numPanelPnlNo.Value), txtPanelPanelName.Text, Convert.ToUInt16(numPanelPanelAddress.Value), (ushort)cboPanelPanelOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 44)
            {
                int Result = -1;
                int PrevPnlRef = 0;
                if (cboRdrConfigAvailableReaders != null && cboRdrConfigAvailableReaders.SelectedItem != null)
                {
                    DataRowView row = (DataRowView)cboRdrConfigAvailableReaders.SelectedItem;
                    PrevPnlRef = Convert.ToInt32(row["PnlRef"].ToString());
                }
                Result = this.caAccess.ReaderConfiguration(PrevPnlRef, Convert.ToInt32(cboRdrConfigAvailableReaders.SelectedValue), Convert.ToInt32(cboRdrConfigPanel.SelectedValue), Convert.ToInt32(numRdrConfigReaderNo.Value), GetReaderGeneralInfo(), GetReaderControlInfo(), GetReaderOptionInfo(), GetReaderPriorityInfo(), (ushort)cboRdrConfigOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 45)
            {
                int Result = -1;
                Result = this.caAccess.LockdownAreaOperation(txtLockdownAreaName.Text, Convert.ToInt32(numLockdownAreasNo.Value), Convert.ToInt32(cboLockdownAreaPanel.SelectedValue), Convert.ToInt32(cboLockdownAreaReader.SelectedValue), chkLockdownUseReader.Checked, (ushort)cboLockdownOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 46)
            {
                int Result = -1;
                Result = this.caAccess.ThreatLevelAreaOperation(txtThreatLevelName.Text, Convert.ToInt32(numThreatLevelNo.Value), Convert.ToInt32(cboLockdownAreaTLM.SelectedValue), radioDenyAccessTLM.Checked, Convert.ToInt32(cboCategoryNoTLM.SelectedValue), txtCategoryNameTLM.Text, chkAssignedCatTLM.Checked, (ushort)cboThreatLevelOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 47)
            {
                int Result = -1;
                Result = this.caAccess.InputOperation(Convert.ToUInt16(cboInputOprPanel.SelectedValue),Convert.ToUInt16(numInputOprNo.Value),txtInputOperationName.Text, Convert.ToBoolean(chkInputOprEnabled.Checked), (ushort)cboInputOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 48)
            {
                int Result = -1;
                Result = this.caAccess.RelayOperation(Convert.ToUInt16(cboRelayOprPanel.SelectedValue), Convert.ToUInt16(numRelayOprNo.Value), txtRelayOprRelayName.Text, Convert.ToUInt16(numRelayOprEnergTime.Value), Convert.ToBoolean(chkRelayOprEnable.Checked), (ushort)cboRelayOprOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 49)
            {
                int Result = -1;
                Result = this.caAccess.NAPCOPanelOperation(Convert.ToUInt16(cboNapcoPanelType.SelectedValue),Convert.ToUInt16(numNapcoPanelNo.Value),txtNapcoPanelName.Text,chkNapcoPanelEnable.Checked,txtNapcoSecurityCode.Text,Convert.ToUInt16(cboNapcoWorkstation.SelectedValue),(ushort)cboNapcoConnType.SelectedIndex,txtNapcoNetAddress.Text, (ushort)cboNapcoPanelOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 50)
            {
                int Result = -1;
                Result = this.caAccess.APBAreasOperation(txtApbAreaName.Text, Convert.ToInt32(numAPBAreaNo.Value), chkAlertOnFirstInLastOutCount.Checked, chkFirstIn.Checked, radioFreeAccessLockdown.Checked, Convert.ToInt32(cboLinkOnVacant.SelectedValue), Convert.ToInt32(cboLinkOnOccupied.SelectedValue), Convert.ToInt32(numNoOfOccupantsIncrease.Value), Convert.ToInt32(cboLinkProgramIncrease.SelectedValue), Convert.ToInt32(numNoOfOccupantsDecrease.Value), Convert.ToInt32(cboLinkProgramDecrease.SelectedValue), (ushort)cboApbAreaConfigOperation.SelectedIndex); 
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 51)
            {
                int Result = -1;
                if(cboAvailableLanguages != null && cboAvailableLanguages.SelectedItem != null)
                {
                    Result = this.caAccess.SetLanguage(Convert.ToInt32(cboAvailableLanguages.SelectedValue));
                }
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 52)
            {
                int Result = -1;
                Guid g = Guid.Empty;
                if(cboAvailableInstructions != null && cboAvailableInstructions.SelectedItem != null)
                    g = Guid.Parse(cboAvailableInstructions.SelectedValue.ToString());
                Result = this.caAccess.OperatorInstructionsOperation(g, txtOperatorInstructionName.Text, richTxtInstructionMsg.Text, (ushort)cboOperatorInstructionsOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 53)
            {
                int Result = -1;
                Guid g = Guid.Empty;
                if (cboInstructionLinkInstruction != null && cboInstructionLinkInstruction.SelectedItem != null)
                    g = Guid.Parse(cboInstructionLinkInstruction.SelectedValue.ToString());
                Result = this.caAccess.OperatorInstructionLinkOperation(Convert.ToInt32(cboInstructionLinkPanel.SelectedValue), cboInstructionLinkDeviceType.SelectedIndex, Convert.ToInt32(cboInstructionLinkDevices.SelectedValue), Convert.ToInt32(cboInstructionLinkEvents.SelectedValue), g, chkInstructionLinkEnableLink.Checked, txtInstructionLinkAlertSound.Text, chkInstructionLinkEnableAlertSound.Checked, Convert.ToInt32(numInstructionLinkInterval.Value), (ushort)cboInstructionLinkOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 54)
            {
                int Result = -1;
                Guid g = Guid.Empty;
                string reps = string.Empty;
                if (cboAvailableOperatorResponse != null && cboAvailableOperatorResponse.SelectedItem != null)
                {
                    g = Guid.Parse(cboAvailableOperatorResponse.SelectedValue.ToString());
                    reps = cboAvailableOperatorResponse.Text;
                }
                Result = this.caAccess.OperatorResponseOperation(g, reps, txtOperatorResponseText.Text, (ushort)cboOperatorResponseOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 55)
            {
                int Result = -1;
                Result = this.caAccess.NAPCOAreaOperation(Convert.ToUInt16(cboNapcoAreaPanel.SelectedValue), Convert.ToUInt16(numNapcoAreaNo.Value), txtNapcoAreaname.Text, chkAreaConfigured.Checked, Convert.ToUInt16(cboNapcoAreaType.SelectedValue), Convert.ToUInt16(cboAreaManualPriv.SelectedValue), chkUseRelayCtrl.Checked, chkUseAccessCtrlPanel.Checked, Convert.ToUInt16(numAreaRelayPanel.Value), Convert.ToUInt16(numAreaRelayNo.Value));
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 56)
            {
                int Result = -1;
                Result = this.caAccess.NAPCOzoneOperation(Convert.ToUInt16(cboNapcoZonePanel.SelectedValue), Convert.ToUInt16(numNapcoZoneNo.Value), txtNapcoZoneName.Text, Convert.ToUInt16(numZoneAreano.Value), chkNapcoZoneConfigured.Checked);
                DisplyResult(Result);
            }

            if (tabControl1.SelectedIndex == 57)
            {
                int Result = -1;
                Result = this.caAccess.NAPCORelayOperation(Convert.ToUInt16(cboNapcoRelayPanel.SelectedValue), Convert.ToUInt16(numNapcoRealyNo.Value), txtNapcoRelayName.Text, chkNapcoRelayConfigured.Checked);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 58)
            {
                int Result = -1;
                Guid g = Guid.Empty;
                if (cboPrevScheduleChanges != null && cboPrevScheduleChanges.SelectedItem != null)
                    g = Guid.Parse(cboPrevScheduleChanges.SelectedValue.ToString());
                Result = this.caAccess.ScheduleChangesOperation(g, txtSchedChangesDescription.Text, Convert.ToInt32(cboSchedChangesPanel.SelectedValue), Convert.ToInt32(cboSchedChangeDeviceType.SelectedValue), Convert.ToInt32(cboSchedChangeDevices.SelectedValue), cboSchedChangeDevices.Text, Convert.ToInt32(cboSchedChangesField.SelectedValue), cboSchedChangesField.Text, Convert.ToInt32(cboSchedChangeSchedules.SelectedValue), dtpSchedChangesDateFrom.Value, dtpSchedChangesDateTo.Value, (ushort)cboSchedChangeOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if(tabControl1.SelectedIndex == 59)
            {
                int Result = -1;
                Result = this.caAccess.FacilityMapPointOperation(Convert.ToUInt16(cboConfigFacilityMap.SelectedValue), Convert.ToUInt16(cboFacilityMapPanel.SelectedValue), Convert.ToUInt16(cboFacilityMapDeviceType.SelectedValue), Convert.ToUInt16(numFacilityDeviceNo.Value), float.Parse(txtMapPointX.Text), float.Parse(txtMapPointY.Text), (ushort)cboFacilityMapOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 60)
            {
                int Result = -1;
                List<APIPanelDevicePair> PanelInputsList = new List<APIPanelDevicePair>();
                DataRowView row;
                foreach (object itemChecked in chkListBoxShuntGroupInputs.CheckedItems)
                {
                    row = itemChecked as DataRowView;
                    PanelInputsList.Add(new APIPanelDevicePair()
                     {
                         PanelNo = Convert.ToInt32(row[1]),
                         DeviceNo = Convert.ToInt32(row[2])
                     });
                }

                Guid g = Guid.Empty;
                if (cboPrevShuntGroups != null && cboPrevShuntGroups.SelectedItem != null)
                {
                    row = (DataRowView)cboPrevShuntGroups.SelectedItem;
                    g = Guid.Parse(row["caObjectID"].ToString());
                }
                
                Result = this.caAccess.ShuntGroupsConfiguration(Convert.ToInt32(cboPrevShuntGroups.SelectedValue), g, txtShuntGroupsNewDescription.Text, PanelInputsList, (ushort)cboShuntGroupConfiguration.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 61)
            {
                int Result = -1;
                Guid g = Guid.Empty;
                if (cboPrevElevatorFacilities != null && cboPrevElevatorFacilities.SelectedItem != null)
                {
                    DataRowView row = (DataRowView)cboPrevElevatorFacilities.SelectedItem;
                    g = Guid.Parse(row["caObjectID"].ToString());
                }
                Result = this.caAccess.ElevatorFacilityConfiguration(Convert.ToUInt16(cboPrevElevatorFacilities.SelectedValue), g, txtElevatorFacilityName.Text, (ushort)cboElevatorFacilityNameOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 62)
            {
                int Result = -1;
                Guid g = Guid.Empty;
                if (cboPrevElevatorServers != null && cboPrevElevatorServers.SelectedItem != null)
                {
                    DataRowView row = (DataRowView)cboPrevElevatorServers.SelectedItem;
                    g = Guid.Parse(row["caObjectID"].ToString());
                }
                Result = this.caAccess.ElevatorServarConfiguration(Convert.ToUInt16(cboPrevElevatorServers.SelectedValue), g, txtElevatorServerName.Text, txtElevatorIPAddress.Text, Convert.ToInt32(cboElevatorType.SelectedValue), Convert.ToInt32(cboElevServerFacilities.SelectedValue), cboEvelServerWorkstations.Text, (ushort)cboElevatorServerOperation.SelectedIndex); 
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 63)
            {
                int Result = -1;
                Guid g = Guid.Empty;
                if (cboPrevElevatorFloors != null && cboPrevElevatorFloors.SelectedItem != null)
                {
                    DataRowView row = (DataRowView)cboPrevElevatorFloors.SelectedItem;
                    g = Guid.Parse(row["caObjectID"].ToString());
                }
                Result = this.caAccess.ElevatorFloorConfiguration(g, Convert.ToInt32(numElevatorFloorNo.Value), Convert.ToInt32(cboElevatorFloorFacilities.SelectedValue), txtElevatorFloorName.Text, (ushort)cboElevatorFloorOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 64)
            {
                int Result = -1;
                Result = this.caAccess.FacilityCodesConfiguration(Convert.ToInt32(cboFacilityCodePanels.SelectedValue), Convert.ToInt32(numFacilityCode1.Value), Convert.ToInt32(numFacilityCode2.Value), Convert.ToInt32(numFacilityCode3.Value), Convert.ToInt32(numFacilityCode4.Value), Convert.ToInt32(numFacilityCode5.Value), Convert.ToInt32(numFacilityCode6.Value), Convert.ToInt32(numFacilityCode7.Value), Convert.ToInt32(numFacilityCode8.Value), Convert.ToInt32(numFacilityCode9.Value), Convert.ToInt32(numFacilityCode10.Value), (ushort)cboFacilityCodeOperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 65)//DVR Server
            {
                int Result = -1;
                Guid DVRServerID = Guid.Empty;
                if (txtDVRServerName.SelectedValue != null && !string.IsNullOrEmpty(txtDVRServerName.SelectedValue.ToString()))
                    DVRServerID = (Guid)txtDVRServerName.SelectedValue;
                else
                    DVRServerID = Guid.NewGuid();

                Result = this.caAccess.DVRServerOperation(Convert.ToUInt16(cboDVRServerType.SelectedValue), txtDVRServerIP.Text, chkDVREnabled.Checked, txtDVRServerName.Text.ToString(), DVRServerID, Convert.ToUInt16(cboDVRServerTimeZone.SelectedValue), txtDVRUserName.Text, txtDVRUserPassword.Text, chkDVRNotification.Checked, (ushort)cboDVROperation.SelectedIndex);
                DisplyResult(Result);
            }
            if (tabControl1.SelectedIndex == 66)//DVR Camera
            {
                int Result = -1;
                Result = this.caAccess.DVRCameraOperation(cboDVRServerID.SelectedValue.ToString(), Convert.ToUInt16(numDVRCameraID.Value), txtDVRCameraName.Text, chkCameraNotification.Checked, Convert.ToUInt16(cboCameraTimeSched.SelectedValue), Convert.ToUInt16(cboCameraPriority.SelectedValue), (ushort)cboDVROperation.SelectedIndex);
                DisplyResult(Result); 
            }
            if (tabControl1.SelectedIndex == 67)//Discover Gateways
            {
                int Result = -1;
                Result = this.caAccess.GatewayOperation(txtHostIpAddress.Text, Convert.ToUInt16(cboGatewayWorkstation.SelectedValue), Convert.ToUInt16(numGatewayComport.Value), txtGatewayPassword.Text, txtGatewayMac.Text,Convert.ToUInt16(cboGatewayZone.SelectedValue), (ushort)cboGatewayOperation.SelectedIndex);
                DisplyResult(Result); 
            }

            if (tabControl1.SelectedIndex == 68)//Discover Lock
            {
                int Result = -1;
                Result = this.caAccess.WirelessLockOperation(Convert.ToUInt16(cboLockComServer.SelectedValue), Convert.ToUInt16(cboLockComport.SelectedValue), txtLockID.Text, Convert.ToUInt16(numLockSearch.Value), (ushort)cboLockOperation.SelectedIndex, txtLockReplaceID.Text);
                DisplyResult(Result);
            }

            if (tabControl1.SelectedIndex == 69)//Link Configuration
            {
                int Result = -1;
                Result = this.caAccess.LinkConfiguration(cboAvailableLink.SelectedValue.ToString(), Convert.ToUInt16(cboLinkPanelNo.SelectedValue), Convert.ToUInt16(numLinkNo.Value), GetLinkGeneralInfo(), GetLinkInputInfo(), GetLinkOutpitInfo(), GetLinkLocatioRemarks(), Convert.ToUInt16(cboLinkOpr.SelectedIndex));
                DisplyResult(Result);
            }

            if (tabControl1.SelectedIndex == 70)//ActivityLink Configuration
            {
                int Result = -1;
                DataRow dr = null;
                List<int> PanelList = new List<int>();
                PanelList.Add(Convert.ToInt32(cboALPPanelNo.SelectedValue));
                if(Convert.ToInt32(cboALPPanelNo.SelectedValue)!=Convert.ToInt32(cboALPGlobalPanel.SelectedValue))
                    PanelList.Add(Convert.ToInt32(cboALPGlobalPanel.SelectedValue));

                DataTable dtRelay = new DataTable("RelayGrid");
                dtRelay.Columns.Add("PanelNo");
                dtRelay.Columns.Add("DeviceNo");
                dtRelay.Columns.Add("Control");
                dr = null;
                dr = dtRelay.NewRow();
                dtRelay.Rows.Add(Convert.ToInt32(cboALPGlobalPanel.SelectedValue),Convert.ToInt32(cboALPRelay.SelectedValue), Convert.ToInt32(cboALPRelayCtrl.SelectedValue));

                DataTable dtReader = new DataTable("ReaderGrid");
                dtReader.Columns.Add("PanelNo");
                dtReader.Columns.Add("DeviceNo");
                dtReader.Columns.Add("Control");
                dr = null;
                dr = dtReader.NewRow();
                dtReader.Rows.Add(Convert.ToInt32(cboALPGlobalPanel.SelectedValue), Convert.ToInt32(cboALPReader.SelectedValue), Convert.ToInt32(cboALPReaderCtrl.SelectedValue));

                DataTable dtInput = new DataTable("InputGrid");
                dtInput.Columns.Add("PanelNo");
                dtInput.Columns.Add("DeviceNo");
                dtInput.Columns.Add("Control");
                dr = null;
                dr = dtInput.NewRow();
                dtInput.Rows.Add(Convert.ToInt32(cboALPGlobalPanel.SelectedValue),Convert.ToInt32(cboALPInput.SelectedValue), Convert.ToInt32(cboALPInputCtrl.SelectedValue));

                DataTable dtPersonnel = new DataTable("PersonnelGrid");
                dtPersonnel.Columns.Add("PanelNo");
                dtPersonnel.Columns.Add("DeviceNo");
                dtPersonnel.Columns.Add("Control");
                dr = null;
                dr = dtPersonnel.NewRow();
                dtPersonnel.Rows.Add(Convert.ToInt32(cboALPGlobalPanel.SelectedValue), Convert.ToInt32(cboALPPersonnel.SelectedValue), Convert.ToInt32(cboALPPersonnelCtrl.SelectedValue));

                Result = this.caAccess.ActivityLinkConfiguration(Convert.ToUInt16(cboALPPanelNo.SelectedValue), Convert.ToUInt16(numALPNo.Value), GetActivityLinkGeneralInfo(), PanelList, dtRelay, dtReader, dtInput, dtPersonnel, Convert.ToUInt16(cboALPOperation.SelectedIndex));
                DisplyResult(Result);
            }
        }

        private APIReaderGeneralInfo GetReaderGeneralInfo()
        {
            return new APIReaderGeneralInfo()
                {
                    ReaderName = txtRdrConfigReaderName.Text,
                    ReaderType = Convert.ToInt32(cboRdrConfigReaderType.SelectedValue),
                    Enabled = chkRdrConfigEnabled.Checked,
                    ReportBypass = chkRdrConfigReportBypass.Checked,
                    BypassUnlock = chkRdrConfigBypassUnlocks.Checked,
                    NoTransForValid = chkRdrConfigNoTransForValid.Checked,
                    TimeShcedViolateOver = chkRdrConfigTimeShcedViolateOver.Checked,
                    ReportAccessAfterOpe = chkRdrConfigReportAccessAfterOpen.Checked,
                    BadgeUseRegister = chkRdrConfigBadgeUseLimitCtrlr.Checked,
                    EscortEnabled = chkRdrConfigEscortEnabled.Checked,
                    NoSound = chkRdrConfigNoSound.Checked,
                    DoubleReadUnlocked = chkRdrConfigDoubleReadUnlocked.Checked,
                    AlarmShuntReader = chkRdrConfigAlarmShuntReader.Checked,
                    MaxShuntTime = Convert.ToInt32(numRdrConfigMaxShuntTime.Value)
                };
        }
        private APIReaderDoorControlInfo GetReaderControlInfo()
        {
            return new APIReaderDoorControlInfo()
             {
                 CardOnlyTimeSchedule = Convert.ToInt32(cboRdrConfigCardOnlyTimeSched.SelectedValue),
                 FreeAccessTimeSchedule = Convert.ToInt32(cboRdrConfigFreeAccessTimeSched.SelectedValue),
                 DegradeModeTimeSchedule = Convert.ToInt32(cboRdrConfigDegradeModeTimeSched.SelectedValue),
                 SensorInput = Convert.ToInt32(numRdrDoorSensorInput.Value),
                 BypassInput = Convert.ToInt32(numRdrConfigBypassInput.Value),
                 StrikeRelay = Convert.ToInt32(numRdrConfigDoorStrikeRelay.Value),
                 KeypadEnabled = chkRdrConfigKeypadEnabled.Checked,
                 DisableDuress = chkRdrConfigDisableDuress.Checked,
                 CommonCode = Convert.ToInt32(numRdrConfigCommonCode.Value),
                 CardPinSchedule = Convert.ToInt32(cboRdrConfigCardPinSched.SelectedValue),
                 CommonCodeSchedule = Convert.ToInt32(cboRdrConfigCommonCodeSched.SelectedValue)

             };
        }
        private APIReaderOptionsInfo GetReaderOptionInfo()
        {
            return new APIReaderOptionsInfo()
            {
                ShuntRelay = Convert.ToInt32(numRdrConfigShuntRelay.Value),
                DoorStrikeTime = Convert.ToInt32(numRdrConfigDoorStrikeTime.Value),
                DoorStrikeTimeType = Convert.ToInt32(cboRdrConfigDoorStrikeTimeType.SelectedValue),
                LockControl = Convert.ToInt32(cboRdrConfigLockControl.SelectedValue),
                TimeAttendanceType = Convert.ToInt32(cboRdrConfigTimeAttendanceType.SelectedValue),
                TwoPersonReaderType = Convert.ToInt32(cboRdrConfigTwoPersonRrdType.SelectedValue),
                MultiBadgeReadTime = Convert.ToInt32(numRdrConfigMultiBadgeReadTime.Value),
                IntrusionDelay = Convert.ToInt32(numRdrConfigIntrusionDelay.Value),
                StdAPBType = Convert.ToInt32(cboRdrConfigStdAPBType.SelectedValue),
                APBExitFromArea = Convert.ToInt32(cboRdrConfigAPBExitFromArea.SelectedValue),
                APBEntryToArea = Convert.ToInt32(cboRdrConfigAPBEntryToArea.SelectedValue),
                APBViolateOverride = chkRdrConfigAPBViolateOver.Checked,
                DurationUseTime = Convert.ToInt32(numRdrConfigDurationUseTime.Value),
                OTLControlType = Convert.ToInt32(cboRdrConfigOTLControlType.SelectedValue),
                StillOpenDelay = Convert.ToInt32(numRdrConfigStillOpenDelay.Value),
                RepeatStillOpenAlert = Convert.ToInt32(numRdrConfigRepeatStillOpenAlert.Value),
                OTLEnableSchedule = Convert.ToInt32(cboRdrConfigOTLEnableSchedule.SelectedValue)
            };
        }
        private APIReaderPriorityInfo GetReaderPriorityInfo()
        {
            return new APIReaderPriorityInfo()
            {
                //Froeced Door
                ForceDoorPrior = Convert.ToInt32(numRdrConfigPriForcedDoor.Value),
                ForcedDoorResp = chkRdrConfigPriForcedDoorResp.Checked,
                ForcedConsoleRelay = chkRdrConfigPriForcedDoorRelay.Checked,
                //Open Too Long
                OpenTooLongPrior = Convert.ToInt32(numRdrConfigPriOpenTooLong.Value),
                OpenTooLongResp = chkRdrConfigPriOpenTooLongResp.Checked,
                OpenTooLongConsoleRelay = chkRdrConfigPriOpenTooLongRelay.Checked,
                //Duress
                DuressPrior = Convert.ToInt32(numRdrConfigPriDuress.Value),
                DuressResp = chkRdrConfigPriDuressResp.Checked,
                DuressConsoleRelay = chkRdrConfigPriDuressRelay.Checked,
                //Tracked Badge
                TrackedBadgePrior = Convert.ToInt32(numRdrConfigPriTrackBadge.Value),
                TrackedBadgeResp = chkRdrConfigPriTrackBadgeResp.Checked,
                TrackedBadgeConsoleRelay = chkRdrConfigPriTrackBadgeRelay.Checked,
                //Void Badge
                VoidBadgePrior = Convert.ToInt32(numRdrConfigPriValidBadge.Value),
                VoidBadgeResp = chkRdrConfigPriValidBadgeResp.Checked,
                VoidBadgeConsoleRelay = chkRdrConfigPriValidBadgeRelay.Checked,
                //APB Violate
                ApbViolatePrior = Convert.ToInt32(numRdrConfigPriAPBViolate.Value),
                ApbViolateResp = chkRdrConfigPriAPBViolateResp.Checked,
                ApbViolateConsoleRelay = chkRdrConfigPriAPBViolateRelay.Checked,
                //Other Denied
                OtherDeniedPrior = Convert.ToInt32(numRdrConfigPriOtherDenied.Value),
                OtherDeniedResp = chkRdrConfigPriOtherDeniedResp.Checked,
                OtherDeniedConsoleRelay = chkRdrConfigPriOtherDeniedRelay.Checked,
                //Bypass
                BypassPrior = Convert.ToInt32(numRdrConfigPriBypass.Value),
                BypassResp = chkRdrConfigPriBypassResp.Checked,
                BypassEnableAck = chkRdrConfigPriBypassAck.Checked,
                //Free Access
                FreeAccessPrior = Convert.ToInt32(numRdrConfigPriFreeAccess.Value),
                FreeAccessResp = chkRdrConfigPriFreeAccessResp.Checked,
                FreeAccessEnableAck = chkRdrConfigPriFreeAccessAck.Checked,
                //Manual Door Control
                ManualDoorPrior = Convert.ToInt32(numRdrConfigPriManualDoorControl.Value),
                ManualDoorResp = chkRdrConfigPriManualDoorControlResp.Checked,
                ManualDoorEnableAck = chkRdrConfigPriManualDoorControlAck.Checked,
                //Common Code
                CommonCodePrior = Convert.ToInt32(numRdrConfigPriCommonCode.Value),
                CommonCodeResp = chkRdrConfigPriCommonCodeResp.Checked,
                CommonCodeEnableAck = chkRdrConfigPriCommonCodeAck.Checked,
                //Valid Access
                ValidAccessPrior = Convert.ToInt32(numRdrConfigPriValidAccess.Value),
                ValidAccessResp = chkRdrConfigPriValidAccessResp.Checked,
                ValidAccessEnableAck = chkRdrConfigPriValidAccessAck.Checked
            };
        }

        private APILinkGenrealInfo GetLinkGeneralInfo()
        {
            return new APILinkGenrealInfo()
            {
                LinkName = txtLinkName.Text,
                EnabledSchedule = Convert.ToInt32(cboLinkEnabledSchedule.SelectedValue),
                AlertPriority = Convert.ToInt32(numLinkAlertPriority.Value),
                ManualPrigilege = Convert.ToInt32(cboLinkManualCtrlPriv.SelectedValue),
                RemoteLinkProgram = cboLinkRemoteProg.SelectedText,
                Enabled = chkLinkEnabled.Checked,
                ReportActivity = chkLinkReportActivity.Checked,
                AlertResponseRequire = chkLinkAlertResponse.Checked,
                DailupActivation = chkLinkDailUp.Checked
            };
        }
        private APILinkInputInfo GetLinkInputInfo()
        {
            return new APILinkInputInfo()
            {
                InputIn1 = Convert.ToInt32(cboLinkInput1.SelectedValue),
                InputIn2 = Convert.ToInt32(cboLinkInput2.SelectedValue),
                InputIn3 = Convert.ToInt32(cboLinkInput3.SelectedValue),
                InputIn4 = Convert.ToInt32(cboLinkInput4.SelectedValue),
                InputIn5 = Convert.ToInt32(cboLinkInput5.SelectedValue),
                TrackSchedule=Convert.ToInt32(cboLinkEnabledSchedule.SelectedValue)
            };
        }
        private APILinkOutputInfo GetLinkOutpitInfo()
        {
            return new APILinkOutputInfo()
            {
                OutputOn1 = Convert.ToInt32(cboLinkOutputOn1.SelectedValue),
                OutputOn2 = Convert.ToInt32(cboLinkOutputOn2.SelectedValue),
                OutputOn3 = Convert.ToInt32(cboLinkOutputOn3.SelectedValue),
                OutputOn4 = Convert.ToInt32(cboLinkOutputOn4.SelectedValue),
                OutputOn5 = Convert.ToInt32(cboLinkOutputOn5.SelectedValue),
                OutputOff1 = Convert.ToInt32(cboLinkOutputOff1.SelectedValue),
                OutputOff2 = Convert.ToInt32(cboLinkOutputOff2.SelectedValue),
                OutputOff3 = Convert.ToInt32(cboLinkOutputOff3.SelectedValue),
                OutputOff4 = Convert.ToInt32(cboLinkOutputOff4.SelectedValue),
                OutputOff5 = Convert.ToInt32(cboLinkOutputOff5.SelectedValue),
                OutputTrack1 = Convert.ToInt32(cboLinkOutputTrack1.SelectedValue),
                OutputTrack2 = Convert.ToInt32(cboLinkOutputTrack2.SelectedValue),
                OutputTrack3 = Convert.ToInt32(cboLinkOutputTrack3.SelectedValue),
                OutputTrack4 = Convert.ToInt32(cboLinkOutputTrack4.SelectedValue),
                OutputTrack5 = Convert.ToInt32(cboLinkOutputTrack5.SelectedValue)
            };
        }
        private APILinkLocatioRemarks GetLinkLocatioRemarks()
        {
            return new APILinkLocatioRemarks()
            {
                Location = txtLinkLocation.Text,
                Remarks = txtLinkRemarks.Text
            };
        }

        private APIActivityLinkGeneralInfo GetActivityLinkGeneralInfo()
        {
            return new APIActivityLinkGeneralInfo()
            {
                Name = txtAcitvityLinkName.Text,
                Priority=Convert.ToInt32(numALPAlertPriority.Value),
                Device=Convert.ToInt32(numALPDeviceNo.Value),
                EventCode= Convert.ToInt32(cboALPEventName.SelectedValue),
                Category=0,
                Schedule=Convert.ToInt32(cboALPCtrlBySchedule.SelectedValue),
                UnDo=chkALPUnDo.Checked,
                Enabled=chkALPEnabled.Checked,
                ManualPrivilege=Convert.ToInt32(cboALPManualPrivilege.SelectedValue),
                UnDoProgNo=Convert.ToInt32(cboALPUndoALP.SelectedValue),
                EnforcedReader=Convert.ToInt32(cboALPEnforcedRdr.SelectedValue)
            };
        }
        private void DisplyResult(int Result)
        {
            switch (Result)
            {
                case 0:
                    this.StatusLabel1.Text = "Successful";
                    break;
                case -1:
                    this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                    break;
                default:
                    this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                    break;
            }
        }

        private void DisplyResult(int Result, string msg)
        {
            switch (Result)
            {
                case 0:
                    this.StatusLabel1.Text = "Successful";
                    break;
                case -1:
                    this.StatusLabel1.Text = "Failed(" + caAccess.LastErrorStr + ")";
                    break;
                case -2:
                    this.StatusLabel1.Text = msg;
                    break;
                case -3:
                    this.StatusLabel1.Text = "Does not fulfill all requirements";
                    break;
                default:
                    this.StatusLabel1.Text = "Rows affected " + Result.ToString();
                    break;
            }
        }

        private void comboBox13_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboReaderPanel.SelectedValue != null)
            {
                try
                {
                    GetReadersList(cboReaderReader, (int)cboReaderPanel.SelectedValue);
                }
                catch { }
            }
        }

        private void comboBox17_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboInlistPanel.SelectedValue != null)
            {
                try
                {
                    GetReadersList(cboInlistReader, (int)cboInlistPanel.SelectedValue);
                    listBoxInlist.Items.Clear();
                }
                catch { }
            }
        }

        private void comboBox16_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboInlistReader.SelectedValue != null)
            {
                listBoxInlist.Items.Clear();
            }
        }

        private void buttonPostEvnet_Click(object sender, EventArgs e)
        {
            if (caAccess.PostEvent(49, comboBoxEvtClass.Text, textBoxDesc.Text, textBoxLoc.Text, checkBoxPending.Checked, 40, checkBoxResp.Checked))
                MessageBox.Show("Event post success.");
            else
                MessageBox.Show("Event post failed!");
        }

        private void cboLinkPanel_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboLinkPanel.SelectedValue != null)
            {
                try
                {
                    GetLinkList(cboLink, (int)cboLinkPanel.SelectedValue);
                }
                catch { }
            }
        }

        private void cboNapcoPanel_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboNapcoPanel.SelectedValue != null)
            {
                try
                {
                    GetNapcoAreaList((int)cboNapcoPanel.SelectedValue);
                }
                catch (Exception ex)
                {
                    
                    throw ex;
                }
            }
        }


        private void LoadAPBAreas()
        {
            DataTable dt = caAccess.GetAPBAreas();
            grdAPBAreas.DataSource = dt;
        }
        private void LoadScripts()
        {
            DataTable dt = caAccess.GetScripts();
            grdScripts.DataSource = dt;
        }
        private void LoadShuntGroups()
        {
            DataTable dt = caAccess.GetShuntGroups();
            grdShuntGroups.DataSource = dt;
        }

        private void cboFindUsagePanel_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboFindUsagePanel.SelectedValue != null && tabControl1.SelectedIndex == 23)//Find Usage)
            {
                try
                {
                    if (Convert.ToInt16(cboFindUsagePanel.SelectedValue) > 0)
                    {
                        DataTable findpnlUsage = caAccess.GetUsage(1, Convert.ToInt16(cboFindUsagePanel.SelectedValue));
                        gdFindUsageCount.DataSource = findpnlUsage;
                    }
                }
                catch { }
            }
        }

        private void cboTSUsage_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboTSUsage.SelectedValue != null && tabControl1.SelectedIndex == 23)
            {
                try
                {
                    if (Convert.ToInt16(cboTSUsage.SelectedValue) > 0)
                    {

                        DataTable findTSUsage = caAccess.GetUsage(2, Convert.ToInt16(cboTSUsage.SelectedValue));
                        gdTimeScheduleUsage.DataSource = findTSUsage;
                    }
                }
                catch { }
            }
        }

        private void cboAGUsage_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboAGUsage.SelectedValue != null && tabControl1.SelectedIndex == 23)
            {
                try
                {
                    if (Convert.ToInt16(cboAGUsage.SelectedValue) > 0)
                    {
                        DataTable findAGUsage = caAccess.GetUsage(3, Convert.ToInt16(cboAGUsage.SelectedValue));
                        gdAGUsage.DataSource = findAGUsage;
                    }
                }
                catch { }
            }
        }

        private void cboFacilityMaps_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (cboFacilityMaps.SelectedValue != null && tabControl1.SelectedIndex == 30)
            {
                try
                {
                    if (((DataRowView)cboFacilityMaps.SelectedItem).Row["MapImage"] != null && !string.IsNullOrEmpty(((DataRowView)cboFacilityMaps.SelectedItem).Row["MapImage"].ToString()))
                    {
                        pbFacilityMaps.Image = null;
                        Size size = pbFacilityMaps.Size;
                        var data = (Byte[])(((DataRowView)cboFacilityMaps.SelectedItem).Row["MapImage"]);
                        var stream = new System.IO.MemoryStream(data);
                        pbFacilityMaps.Image = Image.FromStream(stream);
                        pbFacilityMaps.SizeMode = PictureBoxSizeMode.StretchImage;
                        stream.Close();
                    }
                }
                catch { }
            }
        }

        private void btnMapImport_Click(object sender, EventArgs e)
        {
            ImportPhoto(pbFacilityMaps);
        }

        private void btnPhotoEditImport_Click(object sender, EventArgs e)
        {
            ImportPhoto(pbPhotoEditPhoto);
        }

        private void ImportPhoto(PictureBox picbox)
        {
            try
            {
                OpenFileDialog openFileDialog = new OpenFileDialog();
                openFileDialog.Filter = "Image Files(*.jpg; *.jpeg; *.png; *.gif; *.bmp)|*.jpg; *.jpeg; *.png; *.gif; *.bmp";
                if (openFileDialog.ShowDialog() == DialogResult.OK)
                {
                    Image img = Image.FromFile(openFileDialog.FileName);
                    Bitmap blank = new Bitmap(img.Width, img.Height);
                    Graphics g = Graphics.FromImage(blank);
                    g.Clear(Color.White);
                    g.DrawImage(img, 0, 0, img.Width, img.Height);

                    Bitmap tempImage = new Bitmap(blank);
                    blank.Dispose();
                    img.Dispose();

                    picbox.Image = tempImage;
                    openFileDialog.RestoreDirectory = true;
                }
            }
            catch { }
        }
        private void btnGetPhoto_Click(object sender, EventArgs e)
        {
            try
            {
                Image badgeImg = caAccess.GetBadgePhoto((UInt16) numPhotoEditFacility.Value,(UInt64)Convert.ToInt64(txtPhotoEditBadge.Text));
                pbPhotoEditPhoto.Image = badgeImg;
            }
            catch { }
        }
        private void cboTimeSchedule_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                GetTimeSchedulesTimeBlockIndex(cboTimeBlockIndex, Convert.ToInt32(cboTimeSchedule.SelectedValue));
            }
            catch { }
        }
        private void cboAGSchedulePanel_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                GetReadersList(cboAGScheduleReader, Convert.ToInt32(cboAGSchedulePanel.SelectedValue));
            }
            catch { }
        }
        private void cboHolidaysTimeBlock_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                GetHolidaysTimeBlockIndex(cboHolidayTimeBlockIndex, Convert.ToInt32(cboHolidaysTimeBlock.SelectedValue));
            }
            catch { }
        }
        private void cboLockdownAreaPanel_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                GetReadersList(cboLockdownAreaReader, Convert.ToInt32(cboLockdownAreaPanel.SelectedValue));
            }
            catch { }
        }
        private void cboCategoryNoTLM_SelectedIndexChanged(object sender, EventArgs e)
        {
            try
            {
                if (cboCategoryNoTLM.SelectedItem != null)
                {
                    txtCategoryNameTLM.Text = ((DataRowView)cboCategoryNoTLM.SelectedItem).Row["Description"].ToString();
                }
            }
            catch { }
        }
        private void btnBrowseLanguageLocation_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog openFolderDialog = new FolderBrowserDialog();
            if (openFolderDialog.ShowDialog() == DialogResult.OK)
            {
                txtBrowseLanguageLocation.Text = openFolderDialog.SelectedPath;
                GetAvailableLanguages(cboAvailableLanguages, txtBrowseLanguageLocation.Text);
            }
        }
        private void btnRefreshLanguage_Click(object sender, EventArgs e)
        {
            GetAvailableLanguages(cboAvailableLanguages, txtBrowseLanguageLocation.Text);
        }

        private void cboInstructionLinkPanel_SelectedIndexChanged(object sender, EventArgs e)
        {
            cboInstructionLinkDevices.DataSource = null;
            cboInstructionLinkEvents.DataSource = null;
            if (cboInstructionLinkDeviceType != null && cboInstructionLinkDeviceType.Items.Count > 0)
                cboInstructionLinkDeviceType.SelectedIndex = 0;
        }

        private void cboInstructionLinkDeviceType_SelectedIndexChanged(object sender, EventArgs e)
        {
            GetDevicesByDeviceType(cboInstructionLinkDevices, Convert.ToInt32(cboInstructionLinkPanel.SelectedValue), cboInstructionLinkDeviceType.SelectedIndex);
            GetEventsForInstructionLinks(cboInstructionLinkEvents, cboInstructionLinkDeviceType.SelectedIndex);
        }

        private void cboSchedChangesPanel_SelectedIndexChanged(object sender, EventArgs e)
        {
            cboSchedChangeDevices.DataSource = null;
            GetDevicesByDeviceType(cboSchedChangeDevices, Convert.ToInt32(cboSchedChangesPanel.SelectedValue), cboSchedChangeDeviceType.SelectedIndex);
            GetFieldsByDeviceType(cboSchedChangesField, cboSchedChangeDeviceType.SelectedIndex);
        }

        private void btnGetStatus_Click(object sender, EventArgs e)
        {
            DataTable dtStatus = caAccess.GetStatus(int.Parse(txtStatusType.Text));
            dgStatus.DataSource = dtStatus;
        }
    }
}
